unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, SctBtn, SctVar, ExtCtrls, SctRep, SctCtrl, psetup;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Button1: TButton;
    SctReport1: TSctReport;
    ReportPage: TSctGrouppage;
    ReportHeaderBand: TSctBand;
    ReportHeaderBandlevel: TSctLevel;
    PageHeaderBand: TSctBand;
    PageHeaderBandlevel: TSctLevel;
    DetailBand: TSctBand;
    DetailBandlevel: TSctLevel;
    PageFooterBand: TSctBand;
    PageFooterBandlevel: TSctLevel;
    ReportFooterBand: TSctBand;
    ReportFooterBandlevel: TSctLevel;
    SctReportButton1: TSctReportButton;
    Sctvarlabel1: TSctvarlabel;
    psDialog: TPrinterSetupDialog;
    Sctvarlabel2: TSctvarlabel;
    lbTray1: TSctvarlabel;
    lbTray2: TSctvarlabel;
    grpTray2: TRadioGroup;
    grpTray1: TRadioGroup;
    Label1: TLabel;
    ckUseNum: TCheckBox;
    procedure Button1Click(Sender: TObject);
    procedure PageHeaderBandBeforePrint(Band: TSctBand);
    procedure SctReportButton1BeforeRun(PageSetup: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    tray2Source: TSctPaperSource;
  end;

var
  Form1: TForm1;
  Cnt: integer;

implementation

{$R *.dfm}
uses acepset, acesetup, printers;

function SetBin(binnum: integer): TsctPaperSource;
begin
  case binnum of
    DMBIN_UPPER: Result := psUpper;
    DMBIN_LOWER: Result := psLower;
    DMBIN_MIDDLE: Result := psMiddle;
    DMBIN_MANUAL: Result := psManual;
    DMBIN_ENVELOPE: Result := psEnvelope;
    DMBIN_ENVMANUAL: Result := psEnvelopeManual;
    DMBIN_AUTO: Result := psAuto;
    DMBIN_TRACTOR: Result := psTractor;
    DMBIN_SMALLFMT: Result := psSmallFmt;
    DMBIN_LARGEFMT: Result := psLargeFmt;
    DMBIN_LARGECAPACITY: Result := psLargeCapacity;
    DMBIN_CASSETTE: Result := psCassette;
  else Result := ppsUseCurrent;
  end;

end;

function GetBinName(Source: Integer): String;
begin
  case Source of
    DMBIN_UPPER: Result := 'psUpper';
    DMBIN_LOWER: Result := 'psLower';
    DMBIN_MIDDLE: Result := 'psMiddle';
    DMBIN_MANUAL: Result := 'psManual';
    DMBIN_ENVELOPE: Result := 'psEnvelope';
    DMBIN_ENVMANUAL: Result := 'psEnvelopeManual';
    DMBIN_AUTO: Result := 'psAuto';
    DMBIN_TRACTOR: Result := 'psTractor';
    DMBIN_SMALLFMT: Result := 'psSmallFormat';
    DMBIN_LARGEFMT: Result := 'psLargeFormat';
    DMBIN_LARGECAPACITY: Result := 'psLargeCapacity';
    DMBIN_CASSETTE: Result := 'psCassette';
    {$ifdef WIN32}
    DMBIN_FORMSOURCE: Result := 'psFormSource';
    {$endif}
  else Result := '**Not Supported**';
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
  ap: TAcePrinterInfo;
  bi: TAceBinInfo;
  i: integer;
  sl: TStringlist;
begin
  sl := TStringList.Create;
  psDialog.Execute;
  ap := TAcePrinterInfo.Create();

  for i := 0 to ap.BinList.Count - 1 do
  begin
    bi := TAceBinInfo(ap.BinList.Items[i]);
    sl.Add( IntToStr(bi.binNumber) + ': '
        +bi.binName + ' ---> '
        +GetBinName(bi.BinNumber)  );
  end;
  ap.Free;
  grpTray1.Items.AddStrings(sl);
  grpTray1.ItemIndex := 0;
  grpTray2.Items.AddStrings(sl);
  grpTray2.ItemIndex := 1;
  Label1.Caption := Printer.Printers[Printer.PrinterIndex];
  SctReportButton1.Enabled := True;
end;

procedure TForm1.PageHeaderBandBeforePrint(Band: TSctBand);
var
  pg: TSctPage;
  ap: TAcePrinterInfo;
  bi: TAceBinInfo;
begin
  pg := (Band.Parent as TSctPage);

  if ckUseNum.Checked then
    begin
      //  Note that changing printer settings will affect the
      //  NEXT page, not the current one.
      //
      //  If the printer tray number is not available in ACE,
      //  then you need to use this method and assign the
      //  tray number exlicitly:
      //
      ap := TAcePrinterInfo.Create();
      bi := TAceBinInfo(ap.BinList.Items[grpTray2.ItemIndex]);
      pg.PrintTo.AcePrinterSetup.Source := bi.binNumber;
      ap.Free;
    end
  else
    begin
      //  If the tray is available in ACE,then you can assign it
      //  in the normal way you change printer settings in the
      //  middle of a report:
      //
      pg.PageSetup.Source := Tray2Source;
      pg.PageSetup.LoadSettings;
      pg.PrintTo.AcePrinterSetup.Assign(pg.PageSetup.AcePrinterSetup);
    end;
end;

procedure TForm1.SctReportButton1BeforeRun(PageSetup: TObject);
var
  ap: TAcePrinterInfo;
  bi: TAceBinInfo;
begin
  ap := TAcePrinterInfo.Create();
  bi := TAceBinInfo(ap.BinList.Items[grpTray1.ItemIndex]);
  (PageSetup as TSctPageSetup).Source := SetBin(bi.binNumber);
  lbTray1.Caption := GetBinName(bi.BinNumber);

  bi := TAceBinInfo(ap.BinList.Items[grpTray2.ItemIndex]);
  Tray2Source := SetBin(bi.binNumber);
  if ckUseNum.Checked then
    lbTray2.Caption := 'Bin Number: '+IntToStr(bi.BinNumber)
  else
    lbTray2.Caption := GetBinName(bi.BinNumber);

  ap.Free;

end;

end.
